Package: rtiktoken
Title: A Byte-Pair-Encoding (BPE) Tokenizer for OpenAI's Large Language
        Models
Version: 0.11.0.2
Authors@R: c(
    person("David", "Zimmermann-Kollenda", , "david_j_zimmermann@hotmail.com", role = c("aut", "cre")),
    person("Roger Zurawicki", role = "aut", comment = "tiktoken-rs Rust library"),
    person("Authors of the dependent Rust crates", role = "aut", comment = "see AUTHORS file")
  )
Description: A thin wrapper around the tiktoken-rs crate, allowing to encode text into Byte-Pair-Encoding (BPE) tokens and decode tokens back to text. This is useful to understand how Large Language Models (LLMs) perceive text. 
License: MIT + file LICENSE
URL: https://davzim.github.io/rtiktoken/,
        https://github.com/DavZim/rtiktoken/
BugReports: https://github.com/DavZim/rtiktoken/issues
Suggests: testthat (>= 3.0.0)
SystemRequirements: Cargo (Rust's package manager), rustc >= 1.65.0
Encoding: UTF-8
RoxygenNote: 7.3.3
Config/rextendr/version: 0.5.0
Config/testthat/edition: 3
Config/rtiktoken/MSRV: 1.65.0
Depends: R (>= 4.2)
NeedsCompilation: yes
Packaged: 2026-08-21 14:07:45 UTC; dazimme
Author: David Zimmermann-Kollenda [aut, cre],
  Roger Zurawicki [aut] (tiktoken-rs Rust library),
  Authors of the dependent Rust crates [aut] (see AUTHORS file)
Maintainer: David Zimmermann-Kollenda <david_j_zimmermann@hotmail.com>
Repository: CRAN
Date/Publication: 2026-08-21 17:40:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-08-21 17:58:04 UTC; unix
Archs: rtiktoken.so.dSYM

<!-- README.md is generated from README.Rmd. Please edit that file -->

# rtiktoken

<!-- badges: start -->

[![R-CMD-check](https://github.com/DavZim/rtiktoken/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/DavZim/rtiktoken/actions/workflows/R-CMD-check.yaml)
[![CRAN
status](https://www.r-pkg.org/badges/version/rtiktoken)](https://CRAN.R-project.org/package=rtiktoken)
[![extendr](https://img.shields.io/badge/extendr-%5E0.9.0-276DC2)](https://extendr.rs/extendr/extendr_api/)
<!-- badges: end -->

`{rtiktoken}` is a thin wrapper around
[`tiktoken-rs`](https://github.com/zurawiki/tiktoken-rs) (and in turn
around [OpenAI’s Python library
`tiktoken`](https://github.com/openai/tiktoken)). It provides functions
to encode text into tokens used by OpenAI’s models and decode tokens
back into text using
[BPE](https://en.wikipedia.org/wiki/Byte_pair_encoding) tokenizers. It
is also useful to count the numbers of tokens in a text to guess how
expensive a call to OpenAI’s API would be. Note that all the
tokenization happens offline and no internet connection is required.

Another use-case is to compute similarity scores between texts using
tokens.

Other use-cases can be found in the OpenAI’s cookbook [How to Count
Tokens with
`tiktoken`](https://github.com/openai/openai-cookbook/blob/main/examples/How_to_count_tokens_with_tiktoken.ipynb).

To verify the outputs of the functions, see also [OpenAI’s Tokenizer
Platform](https://platform.openai.com/tokenizer).

## Installation

You can install `rtiktoken` like so:

``` r
# Dev version
# install.packages("devtools")
# devtools::install_github("DavZim/rtiktoken")

# CRAN version
install.packages("rtiktoken")
```

## Example

``` r
library(rtiktoken)

# 1. Encode text into tokens
text <- c(
  "Hello World, this is a text that we are going to use in rtiktoken!",
  "Note that the functions are vectorized! Yay!"
)
tokens <- get_tokens(text, "gpt-4o")
tokens
#> [[1]]
#>  [1] 13225  5922    11   495   382   261  2201   484   581   553  2966   316
#> [13]  1199   306 38742  8251  2488     0
#> 
#> [[2]]
#>  [1]  12038    484    290   9964    553   9727   2110      0 115915      0

# 2. Decode tokens back into text
decoded_text <- decode_tokens(tokens, "gpt-4o")
decoded_text
#> [1] "Hello World, this is a text that we are going to use in rtiktoken!"
#> [2] "Note that the functions are vectorized! Yay!"

# Note that it's not guaranteed to produce the identical text as text-parts
# might be dropped if no token match is found.
identical(text, decoded_text)
#> [1] TRUE

# 3. Count the number of tokens in a text
n_tokens <- get_token_count(text, "gpt-4o")
n_tokens
#> [1] 18 10
```

### Models & Tokenizers

The different OpenAI models use different tokenizers (see also [source
code of
`tikoken-rs`](https://github.com/zurawiki/tiktoken-rs/blob/main/tiktoken-rs/src/tokenizer.rs)
for a full list).

The following models use the following tokenizers (note that all
functions of this package both allow to use the model names as well as
the tokenizer names):

| Model Name | Tokenizer Name |
|----|----|
| Gpt-5 models | `o200k_base` |
| gpt-oss | `o200k_harmony` |
| Gpt-4o models | `o200k_base` |
| ChatGPT models, e.g., `text-embedding-ada-002`, `gpt-3.5-turbo`, `gpt-4-` | `cl100k_base` |
| Code models, e.g., `text-davinci-002`, `text-davinci-003` | `p50k_base` |
| Edit models, e.g., `text-davinci-edit-001`, `code-davinci-edit-001` | `p50k_edit` |
| GPT-3 models, e.g., `davinci` | `r50k_base` or `gpt2` |

## Development

`rtiktoken` is built using `extendr` and `Rust`. To build the package,
you need to have `Rust` installed on your machine.

``` r
rextendr::document()
devtools::document()
```

# Generated by extendr: Do not edit by hand
# nolint start

#' @usage NULL
#' @useDynLib rtiktoken, .registration = TRUE
NULL

rs_get_tokens <- function(text, model) .Call(wrap__rs_get_tokens, text, model)

rs_model_to_tokenizer <- function(model) .Call(wrap__rs_model_to_tokenizer, model)

rs_get_token_count <- function(text, model) .Call(wrap__rs_get_token_count, text, model)

rs_decode_tokens <- function(tokens, model) .Call(wrap__rs_decode_tokens, tokens, model)

# nolint end

#' Converts text to tokens
#'
#' @param text a character string to encode to tokens, can be a vector
#' @param model a model to use for tokenization, either a model name, e.g., `gpt-4o`
#' or a tokenizer, e.g., `o200k_base`.
#' See also [available tokenizers](https://github.com/zurawiki/tiktoken-rs/blob/main/tiktoken-rs/src/tokenizer.rs).
#'
#' @return a vector of tokens for the given text as integer
#' @export
#'
#' @seealso [model_to_tokenizer()], [decode_tokens()]
#'
#' @examples
#' get_tokens("Hello World", "gpt-4o")
#' get_tokens("Hello World", "o200k_base")
#' get_tokens("Hello World", "gpt-5.")
#' get_tokens("Hello World", "text-embedding-3-small")
get_tokens <- function(text, model) {
  if (length(text) > 1) {
    return(lapply(text, function(x) get_tokens_internal(x, model)))
  } else {
    get_tokens_internal(text, model)
  }
}

get_tokens_internal <- function(text, model) {
  res <- tryCatch(
    unwrap_extendr_result(rs_get_tokens(text, model)),
    error = function(e) {
      stop(paste("Could not get tokens from text:", e))
    }
  )
  res
}

test_that("model_to_tokenizer works", {
  expect_equal(model_to_tokenizer("gpt-4o"), "o200k_base")
  expect_equal(model_to_tokenizer("text-embedding-ada-002"), "cl100k_base")
  expect_error(model_to_tokenizer("wrong-model")) # TODO this prints the errors!
})

test_that("get_tokens works", {
  expect_equal(get_tokens("Hello World", "gpt-4o"), c(13225L, 5922L))
  expect_equal(get_tokens("Hello World", "o200k_base"), c(13225L, 5922L))
  expect_equal(get_tokens("Hello World", "gpt-3.5-turbo"), c(9906L, 4435L))
  expect_error(get_tokens("Hello World", "wrong-model"))


  expect_equal(get_tokens(c("Hello World", "Alice Bob"), "gpt-4o"),
               list(c(13225L, 5922L), c(100151L, 22582L)))
})

test_that("decode_tokens works", {
  expect_equal(decode_tokens(c(13225L, 5922L), "gpt-4o"), "Hello World")

  expect_equal(decode_tokens(get_tokens("Hello World 123", "gpt-4o"), "gpt-4o"),
               "Hello World 123")

  text <- c("Hello World 123", "Alice Bob")
  expect_equal(decode_tokens(get_tokens(text, "gpt-4o"), "gpt-4o"),
               text)
})

test_that("get_token_count works", {
  expect_equal(get_token_count("Hello World", "gpt-4o"), 2)
  expect_equal(get_token_count("Hello World 123", "gpt-4o"), 4)

  expect_equal(get_token_count(c("Hello World", "Alice Bob"), "gpt-4o"),
               c(2, 2))
})

#' Decodes tokens back to text
#'
#' @param tokens a vector of tokens to decode, or a list of tokens
#' @param model a model to use for tokenization, either a model name, e.g., `gpt-4o`
#' or a tokenizer, e.g., `o200k_base`.
#' See also [available tokenizers](https://github.com/zurawiki/tiktoken-rs/blob/main/tiktoken-rs/src/tokenizer.rs).
#'
#' @return a character string of the decoded tokens or a vector or strings
#' @export
#'
#' @seealso [model_to_tokenizer()], [get_tokens()]
#'
#' @examples
#' tokens <- get_tokens("Hello World", "gpt-4o")
#' tokens
#' decode_tokens(tokens, "gpt-4o")
#'
#' tokens <- get_tokens(c("Hello World", "Alice Bob Charlie"), "gpt-4o")
#' tokens
#' decode_tokens(tokens, "gpt-4o")
decode_tokens <- function(tokens, model) {
  if (is.list(tokens)) {
    sapply(tokens, function(x) decode_tokens_internal(as.integer(x), model),
           USE.NAMES = FALSE)
  } else {
    decode_tokens_internal(as.integer(tokens), model)
  }
}

decode_tokens_internal <- function(tokens, model) {
  res <- tryCatch(
    unwrap_extendr_result(rs_decode_tokens(tokens, model)),
    error = function(e) {
      stop(paste("Could not decode tokens:", e))
    }
  )
  res
}

#' Returns the number of tokens in a text
#'
#' @param text a character string to encode to tokens, can be a vector
#' @param model a model to use for tokenization, either a model name, e.g., `gpt-4o`
#' or a tokenizer, e.g., `o200k_base`.
#' See also [available tokenizers](https://github.com/zurawiki/tiktoken-rs/blob/main/tiktoken-rs/src/tokenizer.rs).
#'
#' @return the number of tokens in the text, vector of integers
#' @export
#'
#' @seealso [model_to_tokenizer()], [get_tokens()]
#' @export
#'
#' @examples
#' get_token_count("Hello World", "gpt-4o")
#' get_token_count("Hello World", "gpt-5.3")
#' get_token_count("Hello World", "text-embedding-3-small")
get_token_count <- function(text, model) {
  if (length(text) > 1) {
    sapply(text, function(x) unwrap_extendr_result(rs_get_token_count(x, model)),
                  USE.NAMES = FALSE)
  } else {
    unwrap_extendr_result(rs_get_token_count(text, model))
  }
}

#' Gets the name of the tokenizer used by a model
#'
#' @param model the model to use, e.g., `gpt-4o`
#'
#' @return the tokenizer used by the model
#' @export
#'
#' @examples
#' model_to_tokenizer("gpt-4o")
#' model_to_tokenizer("gpt-4-1106-preview")
#' model_to_tokenizer("text-davinci-002")
#' model_to_tokenizer("text-embedding-ada-002")
#' model_to_tokenizer("text-embedding-3-small")
model_to_tokenizer <- function(model) {
  unwrap_extendr_result(rs_model_to_tokenizer(model))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_tokens.R
\name{get_tokens}
\alias{get_tokens}
\title{Converts text to tokens}
\usage{
get_tokens(text, model)
}
\arguments{
\item{text}{a character string to encode to tokens, can be a vector}

\item{model}{a model to use for tokenization, either a model name, e.g., \verb{gpt-4o}
or a tokenizer, e.g., \code{o200k_base}.
See also \href{https://github.com/zurawiki/tiktoken-rs/blob/main/tiktoken-rs/src/tokenizer.rs}{available tokenizers}.}
}
\value{
a vector of tokens for the given text as integer
}
\description{
Converts text to tokens
}
\examples{
get_tokens("Hello World", "gpt-4o")
get_tokens("Hello World", "o200k_base")
get_tokens("Hello World", "gpt-5.")
get_tokens("Hello World", "text-embedding-3-small")
}
\seealso{
\code{\link[=model_to_tokenizer]{model_to_tokenizer()}}, \code{\link[=decode_tokens]{decode_tokens()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_token_count.R
\name{get_token_count}
\alias{get_token_count}
\title{Returns the number of tokens in a text}
\usage{
get_token_count(text, model)
}
\arguments{
\item{text}{a character string to encode to tokens, can be a vector}

\item{model}{a model to use for tokenization, either a model name, e.g., \verb{gpt-4o}
or a tokenizer, e.g., \code{o200k_base}.
See also \href{https://github.com/zurawiki/tiktoken-rs/blob/main/tiktoken-rs/src/tokenizer.rs}{available tokenizers}.}
}
\value{
the number of tokens in the text, vector of integers
}
\description{
Returns the number of tokens in a text
}
\examples{
get_token_count("Hello World", "gpt-4o")
get_token_count("Hello World", "gpt-5.3")
get_token_count("Hello World", "text-embedding-3-small")
}
\seealso{
\code{\link[=model_to_tokenizer]{model_to_tokenizer()}}, \code{\link[=get_tokens]{get_tokens()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/decode.R
\name{decode_tokens}
\alias{decode_tokens}
\title{Decodes tokens back to text}
\usage{
decode_tokens(tokens, model)
}
\arguments{
\item{tokens}{a vector of tokens to decode, or a list of tokens}

\item{model}{a model to use for tokenization, either a model name, e.g., \verb{gpt-4o}
or a tokenizer, e.g., \code{o200k_base}.
See also \href{https://github.com/zurawiki/tiktoken-rs/blob/main/tiktoken-rs/src/tokenizer.rs}{available tokenizers}.}
}
\value{
a character string of the decoded tokens or a vector or strings
}
\description{
Decodes tokens back to text
}
\examples{
tokens <- get_tokens("Hello World", "gpt-4o")
tokens
decode_tokens(tokens, "gpt-4o")

tokens <- get_tokens(c("Hello World", "Alice Bob Charlie"), "gpt-4o")
tokens
decode_tokens(tokens, "gpt-4o")
}
\seealso{
\code{\link[=model_to_tokenizer]{model_to_tokenizer()}}, \code{\link[=get_tokens]{get_tokens()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/model_to_tokenizer.R
\name{model_to_tokenizer}
\alias{model_to_tokenizer}
\title{Gets the name of the tokenizer used by a model}
\usage{
model_to_tokenizer(model)
}
\arguments{
\item{model}{the model to use, e.g., \verb{gpt-4o}}
}
\value{
the tokenizer used by the model
}
\description{
Gets the name of the tokenizer used by a model
}
\examples{
model_to_tokenizer("gpt-4o")
model_to_tokenizer("gpt-4-1106-preview")
model_to_tokenizer("text-davinci-002")
model_to_tokenizer("text-embedding-ada-002")
model_to_tokenizer("text-embedding-3-small")
}
